## etcd 3.2.9+dfsg

=== debian/changelog ===
etcd (3.2.9+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Exclude the sockets from the MD5 sum generation. (Closes: #855876)
  * Use Priority optional
  * Update team name
  * Use wrap-and-sort on debian files
  * Remove dh_golang and golang-any from Depends of source package
  * Use HTTPS URL for d/copyright
  * Switch to XS-Go-Import-Path in d/control

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 20 Nov 2017 23:16:35 +0100

etcd (3.2.9+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix package dependency typo. (Closes: #879791)

 -- Michael Lustfield <michael@lustfield.net>  Wed, 25 Oct 2017 17:48:26 -0500

etcd (3.2.9+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Tim Potter ]
  * New upstream release.

  [ Paul Tagliamonte ]
  * Remove Built-Using from arch:all transitional package

  [ Tim Potter ]
  * Apply commit 5e059fd from upstream
  * Update test fixture modification patch
  * Update /dev/ptmx input/output error patch
  * Another update to test fixture path patch

  [ Andrew Shadura ]
  * Ignore test failures.

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 24 Oct 2017 14:33:51 +0100

=== debian/control ===
Source: etcd
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Jelmer Vernooij <jelmer@debian.org>,
           Dmitry Smirnov <onlyjob@debian.org>,
           Tim Potter <tpot@hpe.com>
Build-Depends: curl,
               debhelper (>= 10),
               dh-golang,
               golang-any,
               golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
               golang-github-boltdb-bolt-dev,
               golang-github-cockroachdb-cmux-dev,
               golang-github-coreos-go-semver-dev (>= 0.2.0~),
               golang-github-coreos-go-systemd-dev,
               golang-github-coreos-pkg-dev (>= 3~),
               golang-github-dgrijalva-jwt-go-v3-dev,
               golang-github-dustin-go-humanize-dev,
               golang-github-ghodss-yaml-dev (>= 1.0.0~),
               golang-github-gogo-protobuf-dev,
               golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
               golang-github-google-btree-dev,
               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
               golang-github-grpc-ecosystem-grpc-gateway-dev (>= 1.2.0~),
               golang-github-jonboulle-clockwork-dev,
               golang-github-kr-pty-dev (>= 1.0.0~),
               golang-github-mattn-go-runewidth-dev (>= 0.0.2~),
               golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3~),
               golang-github-prometheus-client-golang-dev,
               golang-github-prometheus-common-dev (>= 0+git20170220.49fee29),
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-ugorji-go-codec-dev,
               golang-github-urfave-cli-dev,
               golang-github-xiang90-probing-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-time-dev,
               golang-google-grpc-dev,
               golang-gopkg-cheggaaa-pb.v1-dev,
               golang-goprotobuf-dev,
               golang-procfs-dev (>= 0+git20170216.a1dba9c)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/etcd.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/etcd.git
Homepage: https://github.com/coreos/etcd
XS-Go-Import-Path: github.com/coreos/etcd

Package: etcd
Section: oldlibs
Architecture: all
Depends: etcd-client, etcd-server, ${misc:Depends}
Description: Transitional package for etcd-client and etcd-server
 This is a transitional package to ease upgrades for splitting the
 etcd package into a separate client and server piece. It can be
 safely removed.

Package: etcd-server
Architecture: any
Depends: adduser, lsb-base, pipexec, ${misc:Depends}, ${shlibs:Depends}
Suggests: etcd-client
Built-Using: ${misc:Built-Using}
Replaces: etcd (<< 3.1.8+dfsg-1)
Breaks: etcd (<< 3.1.8+dfsg-1)
Description: highly-available key value store -- daemon
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the server binaries.

Package: etcd-client
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Replaces: etcd (<< 3.1.8+dfsg-1)
Breaks: etcd (<< 3.1.8+dfsg-1)
Description: highly-available key value store -- client
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the client binaries.

Package: golang-etcd-server-dev
Provides: golang-github-coreos-etcd-dev
Architecture: all
Depends: golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
         golang-github-boltdb-bolt-dev,
         golang-github-cockroachdb-cmux-dev,
         golang-github-coreos-go-semver-dev (>= 0.2.0~),
         golang-github-coreos-go-systemd-dev,
         golang-github-coreos-pkg-dev,
         golang-github-dgrijalva-jwt-go-v3-dev,
         golang-github-dustin-go-humanize-dev,
         golang-github-ghodss-yaml-dev (>= 1.0.0~),
         golang-github-gogo-protobuf-dev,
         golang-github-golang-groupcache-dev (>= 0.0~git20160516.0.02826c3~),
         golang-github-google-btree-dev,
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
         golang-github-grpc-ecosystem-grpc-gateway-dev (>= 1.2.0~),
         golang-github-jonboulle-clockwork-dev,
         golang-github-kr-pty-dev (>= 1.0.0~),
         golang-github-mattn-go-runewidth-dev (>= 0.0.2~),
         golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3),
         golang-github-prometheus-client-golang-dev,
         golang-github-prometheus-common-dev (>= 0+git20170220.49fee29),
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-ugorji-go-codec-dev,
         golang-github-urfave-cli-dev,
         golang-github-xiang90-probing-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-time-dev,
         golang-google-grpc-dev,
         golang-gopkg-cheggaaa-pb.v1-dev,
         golang-goprotobuf-dev,
         golang-procfs-dev (>= 0+git20170216.a1dba9c),
         ${misc:Depends}
Description: highly-available key value store -- source
 A highly-available key value store for shared configuration and service
 discovery. etcd is inspired by zookeeper and doozer, with a focus on:
 .
  * Simple: curl'able user facing API (HTTP+JSON)
  * Secure: optional SSL client cert authentication
  * Fast: benchmarked 1000s of writes/s per instance
  * Reliable: Properly distributed using Raft
 .
 Etcd uses the Raft consensus algorithm to manage a highly-available replicated
 log.
 .
 This package contains the source.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=golang --with=golang,systemd --parallel --builddirectory=_build

override_dh_auto_test:
	dh_auto_test -- -run=Test || true # TODO: remove "|| true" when the test suite is fixed

# Handle package name (etcd-server) != service name (etcd)
override_dh_installinit:
	dh_installinit -p etcd-server --name=etcd

# Exclude the sockets from the MD5 sum generation,
# see https://bugs.debian.org/855876
override_dh_md5sums:
	dh_md5sums --exclude="127.0.0.1:.*" --exclude="localhost:.*"

## etcd 3.2.17%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DH_GOLANG_GO_GENERATE := 1
 
 %:
 	dh $@ --buildsystem=golang --with=golang,systemd --parallel --builddirectory=_build

## etcd 3.2.17+dfsg

=== debian/changelog ===
etcd (3.2.17+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Fix FTBFS:
     - New upstream release contains regenerated gRPC *.pb.go and *.pb.gw.po
       files (since etcd 3.2.10) which build correctly with the updated gPRC
       packages in Debian.
     - Add "export DH_GOLANG_GO_GENERATE := 1" to debian/rules
       to fix FTBFS by re-generating keys.generated.go at build time
       with the same version of codecgen as golang-github-ugorji-go-codec-dev.
       See also https://github.com/coreos/etcd/issues/8715.
     - Add "Depends: golang-github-ugorji-go-codec" to have codecgen available
       at build time.
    (Closes: #890939)
  * Depend on golang-github-coreos-bbolt-dev, replacing
    golang-github-boltdb-bolt-dev, to "address backend database size
    issue" (since etcd 3.2.10)
  * Revert incoming-outgoing-context.patch (commit 5e059fd from upstream)
    which has been backported upstream in commit d62e39d from v3.3 branch
    to v3.2 branch since etcd 3.2.10
  * Add match-ugorji-go-codec-native-time.Time-support.patch, which updates
    etcd/client/keys{,_test}.go to match the latest
    golang-github-ugorji-go-codec-dev to prevent a new "cannot use
    x.Expiration (type *time.Time) as type time.Time in argument to
    r.encDriver.EncodeTime" error, see https://github.com/ugorji/go/issues/224
    and https://github.com/ugorji/go/commit/8badb25.
  * Apply "cme fix dpkg" to debian/control,
    bumping Standards-Version to 4.1.3, setting Priority to optional,
    and adding Testsuite: autopkgtest-pkg-go, etc.
  * Add myself to the list of Uploaders

 -- Anthony Fok <foka@debian.org>  Fri, 16 Mar 2018 18:20:05 -0600

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: etcd
-Section: net
-Priority: optional
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Jelmer Vernooij <jelmer@debian.org>,
-           Dmitry Smirnov <onlyjob@debian.org>,
-           Tim Potter <tpot@hpe.com>
+           Tim Potter <tpot@hpe.com>,
+           Anthony Fok <foka@debian.org>
+Section: net
+Testsuite: autopkgtest-pkg-go
+Priority: optional
 Build-Depends: curl,
                debhelper (>= 10),
                dh-golang,
                golang-any,
                golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
-               golang-github-boltdb-bolt-dev,
+               golang-github-coreos-bbolt-dev,
                golang-github-cockroachdb-cmux-dev,
                golang-github-coreos-go-semver-dev (>= 0.2.0~),
                golang-github-coreos-go-systemd-dev,
@@ -31,6 +32,7 @@
                golang-github-prometheus-common-dev (>= 0+git20170220.49fee29),
                golang-github-spf13-cobra-dev,
                golang-github-spf13-pflag-dev,
+               golang-github-ugorji-go-codec,
                golang-github-ugorji-go-codec-dev,
                golang-github-urfave-cli-dev,
                golang-github-xiang90-probing-dev,
@@ -42,16 +44,18 @@
                golang-gopkg-cheggaaa-pb.v1-dev,
                golang-goprotobuf-dev,
                golang-procfs-dev (>= 0+git20170216.a1dba9c)
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/etcd.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/etcd.git
 Homepage: https://github.com/coreos/etcd
 XS-Go-Import-Path: github.com/coreos/etcd
 
 Package: etcd
+Architecture: all
 Section: oldlibs
-Architecture: all
-Depends: etcd-client, etcd-server, ${misc:Depends}
+Depends: etcd-client,
+         etcd-server,
+         ${misc:Depends}
 Description: Transitional package for etcd-client and etcd-server
  This is a transitional package to ease upgrades for splitting the
  etcd package into a separate client and server piece. It can be
@@ -59,11 +63,13 @@
 
 Package: etcd-server
 Architecture: any
-Depends: adduser, lsb-base, pipexec, ${misc:Depends}, ${shlibs:Depends}
+Depends: adduser,
+         lsb-base,
+         pipexec,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: etcd-client
 Built-Using: ${misc:Built-Using}
-Replaces: etcd (<< 3.1.8+dfsg-1)
-Breaks: etcd (<< 3.1.8+dfsg-1)
 Description: highly-available key value store -- daemon
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:
@@ -80,10 +86,9 @@
 
 Package: etcd-client
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
-Replaces: etcd (<< 3.1.8+dfsg-1)
-Breaks: etcd (<< 3.1.8+dfsg-1)
 Description: highly-available key value store -- client
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:
@@ -99,10 +104,9 @@
  This package contains the client binaries.
 
 Package: golang-etcd-server-dev
-Provides: golang-github-coreos-etcd-dev
 Architecture: all
 Depends: golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
-         golang-github-boltdb-bolt-dev,
+         golang-github-coreos-bbolt-dev,
          golang-github-cockroachdb-cmux-dev,
          golang-github-coreos-go-semver-dev (>= 0.2.0~),
          golang-github-coreos-go-systemd-dev,
@@ -135,6 +139,7 @@
          golang-goprotobuf-dev,
          golang-procfs-dev (>= 0+git20170216.a1dba9c),
          ${misc:Depends}
+Provides: golang-github-coreos-etcd-dev
 Description: highly-available key value store -- source
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:

=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
pgpsigurlmangle=s/archive\/(v?\d[-\d\.]+).tar.gz/releases\/download\/$1\/$1.tar.gz.asc/,\
 https://github.com/coreos/etcd/releases \
 .*/archive/v?(\d[-\d\.]+)\.tar\.gz

## etcd 3.2.18+dfsg

=== debian/changelog ===
etcd (3.2.18+dfsg-1) unstable; urgency=medium

  [ Alexandre Viau ]
  * Point Vcs-* urls to salsa.debian.org.

  [ Anthony Fok ]
  * New upstream release.
  * Bump Standards-Version to 4.1.4 (no change)
  * Remove match-ugorji-go-codec-native-time.Time-support.patch
    because github.com/ugorji/go/codec@v1.1.1 includes changes to support
    both time.Time and *time.Time correctly for backward compatibility.
    See https://github.com/coreos/etcd/issues/9447
  * {Build-,}Depends on golang-github-ugorji-go-codec-dev (>= 1.1.1~)

 -- Anthony Fok <foka@debian.org>  Tue, 10 Apr 2018 05:02:04 -0600

=== debian/control ===
--- 
+++ 
@@ -33,7 +33,7 @@
                golang-github-spf13-cobra-dev,
                golang-github-spf13-pflag-dev,
                golang-github-ugorji-go-codec,
-               golang-github-ugorji-go-codec-dev,
+               golang-github-ugorji-go-codec-dev (>= 1.1.1~),
                golang-github-urfave-cli-dev,
                golang-github-xiang90-probing-dev,
                golang-golang-x-crypto-dev,
@@ -44,9 +44,9 @@
                golang-gopkg-cheggaaa-pb.v1-dev,
                golang-goprotobuf-dev,
                golang-procfs-dev (>= 0+git20170216.a1dba9c)
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/etcd.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/etcd.git
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
+Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
 Homepage: https://github.com/coreos/etcd
 XS-Go-Import-Path: github.com/coreos/etcd
 
@@ -127,7 +127,7 @@
          golang-github-prometheus-common-dev (>= 0+git20170220.49fee29),
          golang-github-spf13-cobra-dev,
          golang-github-spf13-pflag-dev,
-         golang-github-ugorji-go-codec-dev,
+         golang-github-ugorji-go-codec-dev (>= 1.1.1~),
          golang-github-urfave-cli-dev,
          golang-github-xiang90-probing-dev,
          golang-golang-x-crypto-dev,

## etcd 3.2.26+dfsg

=== Makefile ===
# run from repository root



# Example:
#   make build
#   make clean
#   make docker-clean
#   make docker-start
#   make docker-kill
#   make docker-remove

.PHONY: build
build:
	GO_BUILD_FLAGS="-v" ./build
	./bin/etcd --version
	ETCDCTL_API=3 ./bin/etcdctl version

clean:
	rm -f ./codecov
	rm -rf ./agent-*
	rm -rf ./covdir
	rm -f ./*.coverprofile
	rm -f ./*.log
	rm -f ./bin/Dockerfile-release
	rm -rf ./bin/*.etcd
	rm -rf ./default.etcd
	rm -rf ./tests/e2e/default.etcd
	rm -rf ./gopath
	rm -rf ./gopath.proto
	rm -rf ./release
	rm -f ./snapshot/localhost:*
	rm -f ./integration/127.0.0.1:* ./integration/localhost:*
	rm -f ./clientv3/integration/127.0.0.1:* ./clientv3/integration/localhost:*
	rm -f ./clientv3/ordering/127.0.0.1:* ./clientv3/ordering/localhost:*

docker-clean:
	docker images
	docker image prune --force

docker-start:
	service docker restart

docker-kill:
	docker kill `docker ps -q` || true

docker-remove:
	docker rm --force `docker ps -a -q` || true
	docker rmi --force `docker images -q` || true



# GO_VERSION ?= 1.10.3
GO_VERSION ?= 1.8.7
ETCD_VERSION ?= $(shell git rev-parse --short HEAD || echo "GitNotFound")

TEST_SUFFIX = $(shell date +%s | base64 | head -c 15)
TEST_OPTS ?= PASSES='unit'

TMP_DIR_MOUNT_FLAG = --mount type=tmpfs,destination=/tmp
ifdef HOST_TMP_DIR
	TMP_DIR_MOUNT_FLAG = --mount type=bind,source=$(HOST_TMP_DIR),destination=/tmp
endif



# Example:
#   GO_VERSION=1.8.7 make build-docker-test
#   GO_VERSION=1.9.7 make build-docker-test
#   make build-docker-test
#
#   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
#   GO_VERSION=1.8.7 make push-docker-test
#   GO_VERSION=1.9.7 make push-docker-test
#   make push-docker-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   GO_VERSION=1.9.7 make pull-docker-test
#   make pull-docker-test

build-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/Dockerfile
	docker build \
	  --tag gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  --file ./tests/Dockerfile .
	@mv ./tests/Dockerfile.bak ./tests/Dockerfile

push-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd-test:go$(GO_VERSION)

pull-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-test:go$(GO_VERSION)



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make compile-setup-gopath-with-docker-test

compile-with-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker run \
	  --rm \
	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "GO_BUILD_FLAGS=-v ./build && ./bin/etcd --version"

compile-setup-gopath-with-docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker run \
	  --rm \
	  --mount type=bind,source=`pwd`,destination=/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && ETCD_SETUP_GOPATH=1 GO_BUILD_FLAGS=-v ./build && ./bin/etcd --version && rm -rf ./gopath"



# Example:
#
# Local machine:
#   TEST_OPTS="PASSES='fmt'" make test
#   TEST_OPTS="PASSES='fmt bom dep build unit'" make test
#   TEST_OPTS="PASSES='build unit release integration_e2e functional'" make test
#   TEST_OPTS="PASSES='build grpcproxy'" make test
#
# Example (test with docker):
#   make pull-docker-test
#   TEST_OPTS="PASSES='fmt'" make docker-test
#   TEST_OPTS="VERBOSE=2 PASSES='unit'" make docker-test
#
# Travis CI (test with docker):
#   TEST_OPTS="PASSES='fmt bom dep build unit'" make docker-test
#
# Semaphore CI (test with docker):
#   TEST_OPTS="PASSES='build unit release integration_e2e functional'" make docker-test
#   HOST_TMP_DIR=/tmp TEST_OPTS="PASSES='build unit release integration_e2e functional'" make docker-test
#   TEST_OPTS="GOARCH=386 PASSES='build unit integration_e2e'" make docker-test
#
# grpc-proxy tests (test with docker):
#   TEST_OPTS="PASSES='build grpcproxy'" make docker-test
#   HOST_TMP_DIR=/tmp TEST_OPTS="PASSES='build grpcproxy'" make docker-test

.PHONY: test
test:
	$(info TEST_OPTS: $(TEST_OPTS))
	$(info log-file: test-$(TEST_SUFFIX).log)
	$(TEST_OPTS) ./test 2>&1 | tee test-$(TEST_SUFFIX).log
	! egrep "(--- FAIL:|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log

docker-test:
	$(info GO_VERSION: $(GO_VERSION))
	$(info ETCD_VERSION: $(ETCD_VERSION))
	$(info TEST_OPTS: $(TEST_OPTS))
	$(info log-file: test-$(TEST_SUFFIX).log)
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "$(TEST_OPTS) ./test 2>&1 | tee test-$(TEST_SUFFIX).log"
	! egrep "(--- FAIL:|panic: test timed out|appears to have leaked)" -B50 -A10 test-$(TEST_SUFFIX).log

docker-test-coverage:
	$(info GO_VERSION: $(GO_VERSION))
	$(info ETCD_VERSION: $(ETCD_VERSION))
	$(info log-file: docker-test-coverage-$(TEST_SUFFIX).log)
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`,destination=/go/src/github.com/coreos/etcd \
	  gcr.io/etcd-development/etcd-test:go$(GO_VERSION) \
	  /bin/bash -c "COVERDIR=covdir PASSES='build build_cov cov' ./test 2>&1 | tee docker-test-coverage-$(TEST_SUFFIX).log && /codecov -t 6040de41-c073-4d6f-bbf8-d89256ef31e1"
	! egrep "(--- FAIL:|panic: test timed out|appears to have leaked)" -B50 -A10 docker-test-coverage-$(TEST_SUFFIX).log



# Example:
#   make compile-with-docker-test
#   ETCD_VERSION=v3-test make build-docker-release-master
#   ETCD_VERSION=v3-test make push-docker-release-master
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com

build-docker-release-master:
	$(info ETCD_VERSION: $(ETCD_VERSION))
	cp ./Dockerfile-release ./bin/Dockerfile-release
	docker build \
	  --tag gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
	  --file ./bin/Dockerfile-release \
	  ./bin
	rm -f ./bin/Dockerfile-release

	docker run \
	  --rm \
	  gcr.io/etcd-development/etcd:$(ETCD_VERSION) \
	  /bin/sh -c "/usr/local/bin/etcd --version && ETCDCTL_API=3 /usr/local/bin/etcdctl version"

push-docker-release-master:
	$(info ETCD_VERSION: $(ETCD_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd:$(ETCD_VERSION)



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make build-docker-static-ip-test
#
#   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
#   make push-docker-static-ip-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-static-ip-test
#
#   make docker-static-ip-test-certs-run
#   make docker-static-ip-test-certs-metrics-proxy-run

build-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/docker-static-ip/Dockerfile
	docker build \
	  --tag gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  --file ./tests/docker-static-ip/Dockerfile \
	  ./tests/docker-static-ip
	@mv ./tests/docker-static-ip/Dockerfile.bak ./tests/docker-static-ip/Dockerfile

push-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION)

pull-docker-static-ip-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION)

docker-static-ip-test-certs-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-static-ip/certs,destination=/certs \
	  gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"

docker-static-ip-test-certs-metrics-proxy-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-static-ip/certs-metrics-proxy,destination=/certs-metrics-proxy \
	  gcr.io/etcd-development/etcd-static-ip-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs-metrics-proxy/run.sh && rm -rf m*.etcd"



# Example:
#   make build-docker-test
#   make compile-with-docker-test
#   make build-docker-dns-test
#
#   gcloud docker -- login -u _json_key -p "$(cat /etc/gcp-key-etcd-development.json)" https://gcr.io
#   make push-docker-dns-test
#
#   gsutil -m acl ch -u allUsers:R -r gs://artifacts.etcd-development.appspot.com
#   make pull-docker-dns-test
#
#   make docker-dns-test-insecure-run
#   make docker-dns-test-certs-run
#   make docker-dns-test-certs-gateway-run
#   make docker-dns-test-certs-wildcard-run
#   make docker-dns-test-certs-common-name-auth-run
#   make docker-dns-test-certs-common-name-multi-run

build-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	@sed -i.bak 's|REPLACE_ME_GO_VERSION|$(GO_VERSION)|g' ./tests/docker-dns/Dockerfile
	docker build \
	  --tag gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  --file ./tests/docker-dns/Dockerfile \
	  ./tests/docker-dns
	@mv ./tests/docker-dns/Dockerfile.bak ./tests/docker-dns/Dockerfile

	docker run \
	  --rm \
	  --dns 127.0.0.1 \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "/etc/init.d/bind9 start && cat /dev/null >/etc/hosts && dig etcd.local"

push-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	gcloud docker -- push gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION)

pull-docker-dns-test:
	$(info GO_VERSION: $(GO_VERSION))
	docker pull gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION)

docker-dns-test-insecure-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/insecure,destination=/insecure \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /insecure/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/certs,destination=/certs \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-gateway-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \
	  --mount type=bind,source=`pwd`/bin,destination=/etcd \
	  --mount type=bind,source=`pwd`/tests/docker-dns/certs-gateway,destination=/certs-gateway \
	  gcr.io/etcd-development/etcd-dns-test:go$(GO_VERSION) \
	  /bin/bash -c "cd /etcd && /certs-gateway/run.sh && rm -rf m*.etcd"

docker-dns-test-certs-wildcard-run:
	$(info GO_VERSION: $(GO_VERSION))
	$(info HOST_TMP_DIR: $(HOST_TMP_DIR))
	$(info TMP_DIR_MOUNT_FLAG: $(TMP_DIR_MOUNT_FLAG))
	docker run \
	  --rm \
	  --tty \
	  --dns 127.0.0.1 \
	  $(TMP_DIR_MOUNT_FLAG) \

=== debian/changelog ===
etcd (3.2.26+dfsg-6ubuntu0.2) focal-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 18 Jan 2023 15:36:43 +0100

etcd (3.2.26+dfsg-6ubuntu0.1) focal-security; urgency=medium

  * Fix FTBFS build dependency on prometheus
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2020-15106_15112.patch: wal: check out of range
    slice in "ReadAll", "decoder"
    - debian/patches/CVE-2020-15113.patch: pkg: consider umask when use
    MkdirAll
    - debian/patches/CVE-2020-15114.patch: etcdmain: best effort
    detection of self pointing in tcp proxy
    - CVE-2020-15106
    - CVE-2020-15112
    - CVE-2020-15113
    - CVE-2020-15114

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Tue, 20 Sep 2022 17:27:56 +0200

etcd (3.2.26+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Rebuild using newer golang-golang-x-net-dev

 -- Stephen Gelman <ssgelm@debian.org>  Fri, 10 Jan 2020 09:29:10 -0600

etcd (3.2.26+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Add patch to fix FTBFS with newer prometheus version (Closes: #947939)
  * Build-Depends on golang-github-prometheus-client-golang-dev (>= 1.0.0~)

 -- Stephen Gelman <ssgelm@debian.org>  Fri, 10 Jan 2020 01:15:15 -0600

etcd (3.2.26+dfsg-4) unstable; urgency=medium

  * Team upload.

  [ Arnaud Rebillout ]
  * Add upstream patch to build against golang-google-grpc-dev in sid.
  * Add upstream patch to fix test with go 1.12.

  [ Dmitry Smirnov ]
  * (Build-)Depends:
    - golang-github-dgrijalva-jwt-go-v3-dev
    + golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~)

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Fri, 25 Oct 2019 16:51:45 +1100

etcd (3.2.26+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Add patch to increase the latency in test to support mips
  * Fix override_dh_auto_test-does-not-check-DEB_BUILD_OPTIONS
  * Don't ship etcd2-backup-coreos, which is intended for coreos
  * Add spelling-error.patch
  * Remove obsoleted lintian-overrides
  * Update etcd and etcdctl manpage for 3.2.26 version

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 25 Feb 2019 02:25:00 +0800

etcd (3.2.26+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Add missing systemd service after compat bumped to 11
  * Only run unit tests when building, and don't ignore the results
  * Add patch to fix goroutine leak in TestDialNoTimeout

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 24 Feb 2019 23:57:42 +0800

etcd (3.2.26+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Arnaud Rebillout ]
  * {Build-,}Depends on golang-github-xiang90-probing-dev (>= 0.0.1~)
  * Build-Depends on golang-any (>= 2:1.10~)

  [ Shengjing Zhu ]
  * New upstream release v3.2.26
    + Address CVE-2018-16886 (Closes: #923008)
      Disable CommonName authentication for gRPC-gateway
      gRPC-gateway proxy requests to etcd server use the etcd
      client server TLS certificate. If that certificate contains
      CommonName we do not want to use that for authentication as
      it could lead to permission escalation.
  * Remove pgpsigurlmangle in debian/watch.
    Upstream didn't sign the source tarball since v3.2.26
  * Update pkg-go team address to team+pkg-go@tracker.debian.org
  * Update debhelper and compat to 11
  * Update etcd server default env from upstream docs
  * Remove etcd-dump-db, etcd-dump-logs in etcd-client package
    upstream didn't provide these tools in v3.2.26 tarball
  * Add golang-go.uber-zap-dev to {Build-,}Depends
  * Remove socket files created during test phase

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 24 Feb 2019 02:26:48 +0800

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,23 @@
 Source: etcd
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Jelmer Vernooij <jelmer@debian.org>,
            Tim Potter <tpot@hpe.com>,
-           Anthony Fok <foka@debian.org>
+           Anthony Fok <foka@debian.org>,
 Section: net
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends: curl,
-               debhelper (>= 10),
+               debhelper (>= 11),
                dh-golang,
-               golang-any,
+               golang-any (>= 2:1.10~),
                golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
+               golang-github-cockroachdb-cmux-dev,
                golang-github-coreos-bbolt-dev,
-               golang-github-cockroachdb-cmux-dev,
                golang-github-coreos-go-semver-dev (>= 0.2.0~),
                golang-github-coreos-go-systemd-dev,
                golang-github-coreos-pkg-dev (>= 3~),
-               golang-github-dgrijalva-jwt-go-v3-dev,
+               golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
                golang-github-dustin-go-humanize-dev,
                golang-github-ghodss-yaml-dev (>= 1.0.0~),
                golang-github-gogo-protobuf-dev,
@@ -28,14 +29,15 @@
                golang-github-kr-pty-dev (>= 1.0.0~),
                golang-github-mattn-go-runewidth-dev (>= 0.0.2~),
                golang-github-olekukonko-tablewriter-dev (>= 0.0~git20170122.0.a0225b3~),
-               golang-github-prometheus-client-golang-dev,
+               golang-github-prometheus-client-golang-dev (>= 0.9.2),
                golang-github-prometheus-common-dev (>= 0+git20170220.49fee29),
                golang-github-spf13-cobra-dev,
                golang-github-spf13-pflag-dev,
                golang-github-ugorji-go-codec,
                golang-github-ugorji-go-codec-dev (>= 1.1.1~),
                golang-github-urfave-cli-dev,
-               golang-github-xiang90-probing-dev,
+               golang-github-xiang90-probing-dev (>= 0.0.1~),
+               golang-go.uber-zap-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
@@ -43,7 +45,7 @@
                golang-google-grpc-dev,
                golang-gopkg-cheggaaa-pb.v1-dev,
                golang-goprotobuf-dev,
-               golang-procfs-dev (>= 0+git20170216.a1dba9c)
+               golang-procfs-dev (>= 0+git20170216.a1dba9c),
 Standards-Version: 4.1.4
 Vcs-Browser: https://salsa.debian.org/go-team/packages/etcd
 Vcs-Git: https://salsa.debian.org/go-team/packages/etcd.git
@@ -55,7 +57,7 @@
 Section: oldlibs
 Depends: etcd-client,
          etcd-server,
-         ${misc:Depends}
+         ${misc:Depends},
 Description: Transitional package for etcd-client and etcd-server
  This is a transitional package to ease upgrades for splitting the
  etcd package into a separate client and server piece. It can be
@@ -67,9 +69,9 @@
          lsb-base,
          pipexec,
          ${misc:Depends},
-         ${shlibs:Depends}
-Suggests: etcd-client
-Built-Using: ${misc:Built-Using}
+         ${shlibs:Depends},
+Suggests: etcd-client,
+Built-Using: ${misc:Built-Using},
 Description: highly-available key value store -- daemon
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:
@@ -87,8 +89,8 @@
 Package: etcd-client
 Architecture: any
 Depends: ${misc:Depends},
-         ${shlibs:Depends}
-Built-Using: ${misc:Built-Using}
+         ${shlibs:Depends},
+Built-Using: ${misc:Built-Using},
 Description: highly-available key value store -- client
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:
@@ -106,12 +108,12 @@
 Package: golang-etcd-server-dev
 Architecture: all
 Depends: golang-github-bgentry-speakeasy-dev (>= 0.1.0~),
+         golang-github-cockroachdb-cmux-dev,
          golang-github-coreos-bbolt-dev,
-         golang-github-cockroachdb-cmux-dev,
          golang-github-coreos-go-semver-dev (>= 0.2.0~),
          golang-github-coreos-go-systemd-dev,
          golang-github-coreos-pkg-dev,
-         golang-github-dgrijalva-jwt-go-v3-dev,
+         golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
          golang-github-dustin-go-humanize-dev,
          golang-github-ghodss-yaml-dev (>= 1.0.0~),
          golang-github-gogo-protobuf-dev,
@@ -129,7 +131,8 @@
          golang-github-spf13-pflag-dev,
          golang-github-ugorji-go-codec-dev (>= 1.1.1~),
          golang-github-urfave-cli-dev,
-         golang-github-xiang90-probing-dev,
+         golang-github-xiang90-probing-dev (>= 0.0.1~),
+         golang-go.uber-zap-dev,
          golang-golang-x-crypto-dev,
          golang-golang-x-net-dev,
          golang-golang-x-sys-dev,
@@ -138,8 +141,8 @@
          golang-gopkg-cheggaaa-pb.v1-dev,
          golang-goprotobuf-dev,
          golang-procfs-dev (>= 0+git20170216.a1dba9c),
-         ${misc:Depends}
-Provides: golang-github-coreos-etcd-dev
+         ${misc:Depends},
+Provides: golang-github-coreos-etcd-dev,
 Description: highly-available key value store -- source
  A highly-available key value store for shared configuration and service
  discovery. etcd is inspired by zookeeper and doozer, with a focus on:

=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
 https://github.com/coreos/etcd/releases \
 .*/archive/v?(\d[-\d\.]+)\.tar\.gz
